using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// QUICK AND DIRTY OBJECT POOL BUILT IN 30 MINS FUCK YEAH

public class GameObjectPool {
  private List<GameObject> spentPool;
  private List<GameObject> availPool;
  private GameObject gameObject;

  public GameObjectPool(GameObject prefab) {
    spentPool = new List<GameObject>();
    availPool = new List<GameObject>();
    gameObject = prefab;
  }

  public GameObject Instantiate(GameObject obj) {
    RestockPool();
    var newObj = availPool[0];
    availPool.RemoveAt(0);
    spentPool.Add(newObj);
    newObj.SetActive(true);
    return newObj;
  }

  public void Destroy(GameObject obj) {
    obj.SetActive(false);
    spentPool.Remove(obj);
    availPool.Add(obj);
  }

  private void RestockPool() {
    if (availPool.Count > 0) return;

    var newObjCount = spentPool.Count + availPool.Count + 1;
    for (var i = 0; i < newObjCount; i++) {
      var obj = MonoBehaviour.Instantiate(gameObject);
      obj.SetActive(false);
      availPool.Add(obj);
    }
  }
}
