using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraZoomer : MonoBehaviour {
  public float initialDelay;
  public float zoomUnitsPerSec;
  public float maxZoom;

  private bool isZooming = false;

  void Update() {
    if (isZooming) return;

    if (initialDelay > 0f) {
      initialDelay -= Time.deltaTime;
    } else {
      LeanTween.moveZ(gameObject, maxZoom, Mathf.Abs(maxZoom - Camera.main.transform.position.z) / Mathf.Abs(zoomUnitsPerSec)).setEaseInOutQuad();
      isZooming = true;
      // if (Mathf.Abs(Camera.main.transform.position.z) < maxZoomAbs) {
      //   Camera.main.transform.Translate(0f, 0f, -zoomUnitsPerSec * Time.deltaTime);
      // }
    }
  }
}
